Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ManagerDialog.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ManagerDialog.java	(revision 15582)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ManagerDialog.java	(revision 15582)
@@ -0,0 +1,410 @@
+package org.openstreetmap.josm.plugins.czechaddress.gui;
+
+import java.awt.Component;
+import java.awt.event.MouseEvent;
+import java.util.ArrayList;
+import java.util.List;
+import javax.swing.DefaultComboBoxModel;
+import javax.swing.JComboBox;
+import javax.swing.JTable;
+import javax.swing.event.TableModelListener;
+import javax.swing.table.DefaultTableCellRenderer;
+import javax.swing.table.TableModel;
+import org.openstreetmap.josm.plugins.czechaddress.gui.utils.UniversalTreeRenderer;
+import org.openstreetmap.josm.Main;
+import org.openstreetmap.josm.gui.ExtendedDialog;
+import org.openstreetmap.josm.plugins.czechaddress.CzechAddressPlugin;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.AddressElement;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Database;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.House;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Region;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Street;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Suburb;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.ViToCi;
+import org.openstreetmap.josm.plugins.czechaddress.gui.databaseeditors.StreetEditor;
+import org.openstreetmap.josm.plugins.czechaddress.intelligence.Capitalizator;
+import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
+
+public class ManagerDialog extends ExtendedDialog {
+
+    RenameModel<Street> streetModel = new RenameModel<Street>();
+
+    public ManagerDialog() {
+        super(Main.parent, "Inspektor databáze", new String[] {}, true);
+        initComponents();
+
+        dbTree.setModel(new DatabaseModel());
+        dbTree.setCellRenderer(new UniversalTreeRenderer());
+
+        Capitalizator cap = new Capitalizator(
+                                Main.ds.allPrimitives(),
+                                CzechAddressPlugin.getLocation().getStreets());
+
+        for (Street capStreet : cap.getCapitalised()) {
+            assert cap.translate(capStreet).get("name") != null : capStreet;
+
+            String elemName = capStreet.getName();
+            String primName = cap.translate(capStreet).get("name");
+
+            if (!elemName.equals(primName)) {
+                streetModel.elems.add(capStreet);
+                streetModel.names.add(primName);
+            }
+        }
+
+        renameTable.setModel(streetModel);
+        renameTable.setDefaultRenderer( AddressElement.class,
+                                        new AddressElementRenderer());
+        renameTable.setDefaultRenderer( String.class,
+                                        new AddressElementRenderer());
+
+        // And finalize initializing the form.
+        setupDialog(mainPanel, new String[] {});
+    }
+
+    public int countAutomaticRenameProposals() {
+        return streetModel.getRowCount();
+    }
+
+    private class DatabaseModel extends HalfCookedTreeModel {
+
+        @Override
+        public Object getRoot() {
+            return CzechAddressPlugin.getLocation();
+        }
+
+        public Object getChild(Object parent, int index) {
+
+            if (parent instanceof House)
+                return null;
+
+            if (parent instanceof Street)
+                return ((Street) parent).getHouses().get(index);
+
+            if (parent instanceof Suburb) {
+                Suburb suburb = (Suburb) parent;
+
+                if (index< suburb.getHouses().size())
+                    return suburb.getHouses().get(index);
+                else
+                    index -= suburb.getHouses().size();
+
+                if (index< suburb.getStreets().size())
+                    return suburb.getStreets().get(index);
+                else
+                    return null;
+            }
+
+            if (parent instanceof ViToCi) {
+                ViToCi vitoci = (ViToCi) parent;
+
+                if (index< vitoci.getHouses().size())
+                    return vitoci.getHouses().get(index);
+                else
+                    index -= vitoci.getHouses().size();
+
+                if (index< vitoci.getStreets().size())
+                    return vitoci.getStreets().get(index);
+                else
+                    index -= vitoci.getStreets().size();
+
+                if (index< vitoci.getSuburbs().size())
+                    return vitoci.getSuburbs().get(index);
+                else
+                    return null;
+            }
+
+            if (parent instanceof Region) {
+                Region region = (Region) parent;
+
+                if (index< region.getHouses().size())
+                    return region.getHouses().get(index);
+                else
+                    index -= region.getHouses().size();
+
+                if (index< region.getStreets().size())
+                    return region.getStreets().get(index);
+                else
+                    index -= region.getStreets().size();
+
+                if (index< region.getViToCis().size())
+                    return region.getViToCis().get(index);
+                else
+                    return null;
+            }
+
+            if (parent instanceof Database)
+                return ((Database) parent).regions.get(index);
+
+            return null;
+        }
+
+        public int getChildCount(Object parent) {
+
+            if (parent instanceof House)
+                return 0;
+
+            if (parent instanceof Street)
+                return ((Street) parent).getHouses().size();
+
+            if (parent instanceof Suburb)
+                return ((Suburb) parent).getHouses().size() +
+                       ((Suburb) parent).getStreets().size();
+
+            if (parent instanceof ViToCi)
+                return ((ViToCi) parent).getHouses().size() +
+                       ((ViToCi) parent).getStreets().size() +
+                       ((ViToCi) parent).getSuburbs().size();
+
+            if (parent instanceof Region)
+                return ((Region) parent).getHouses().size() +
+                       ((Region) parent).getStreets().size() +
+                       ((Region) parent).getViToCis().size();
+
+            if (parent instanceof Database)
+                return ((Database) parent).regions.size();
+
+            return 0;
+        }
+
+        public int getIndexOfChild(Object parent, Object child) {
+            return 0;
+        }
+        
+    }
+
+    /** This method is called from within the constructor to
+     * initialize the form.
+     * WARNING: Do NOT modify this code. The content of this method is
+     * always regenerated by the Form Editor.
+     */
+    @SuppressWarnings("unchecked")
+    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
+    private void initComponents() {
+
+        mainPanel = new javax.swing.JPanel();
+        tabbedPane = new javax.swing.JTabbedPane();
+        jPanel1 = new javax.swing.JPanel();
+        streetScrollPane = new javax.swing.JScrollPane();
+        renameTable = new javax.swing.JTable();
+        renamerButton = new javax.swing.JButton();
+        jPanel2 = new javax.swing.JPanel();
+        jScrollPane1 = new javax.swing.JScrollPane();
+        dbTree = new javax.swing.JTree();
+        dbEditButton = new javax.swing.JButton();
+
+        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
+        getContentPane().setLayout(new java.awt.GridLayout(1, 0));
+
+        mainPanel.setLayout(new java.awt.GridLayout(1, 0));
+
+        renameTable.setModel(new javax.swing.table.DefaultTableModel(
+            new Object [][] {
+                {null, null},
+                {null, null},
+                {null, null},
+                {null, null}
+            },
+            new String [] {
+                "Původní název", "Návrh z mapy"
+            }
+        ) {
+            Class[] types = new Class [] {
+                java.lang.Object.class, java.lang.String.class
+            };
+            boolean[] canEdit = new boolean [] {
+                false, true
+            };
+
+            public Class getColumnClass(int columnIndex) {
+                return types [columnIndex];
+            }
+
+            public boolean isCellEditable(int rowIndex, int columnIndex) {
+                return canEdit [columnIndex];
+            }
+        });
+        renameTable.setColumnSelectionAllowed(true);
+        streetScrollPane.setViewportView(renameTable);
+
+        renamerButton.setText("Použít navržené změny");
+        renamerButton.addActionListener(new java.awt.event.ActionListener() {
+            public void actionPerformed(java.awt.event.ActionEvent evt) {
+                renamerButtonActionPerformed(evt);
+            }
+        });
+
+        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
+        jPanel1.setLayout(jPanel1Layout);
+        jPanel1Layout.setHorizontalGroup(
+            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
+            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
+                .addContainerGap(253, Short.MAX_VALUE)
+                .addComponent(renamerButton)
+                .addContainerGap())
+            .addComponent(streetScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 426, Short.MAX_VALUE)
+        );
+        jPanel1Layout.setVerticalGroup(
+            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
+            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
+                .addComponent(streetScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 342, Short.MAX_VALUE)
+                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
+                .addComponent(renamerButton)
+                .addContainerGap())
+        );
+
+        tabbedPane.addTab("Návrhy na přejmenování", jPanel1);
+
+        dbTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
+            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
+                dbTreeValueChanged(evt);
+            }
+        });
+        jScrollPane1.setViewportView(dbTree);
+
+        dbEditButton.setText("Upravit");
+        dbEditButton.setEnabled(false);
+        dbEditButton.addActionListener(new java.awt.event.ActionListener() {
+            public void actionPerformed(java.awt.event.ActionEvent evt) {
+                dbEditButtonActionPerformed(evt);
+            }
+        });
+
+        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
+        jPanel2.setLayout(jPanel2Layout);
+        jPanel2Layout.setHorizontalGroup(
+            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
+            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 426, Short.MAX_VALUE)
+            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
+                .addContainerGap(356, Short.MAX_VALUE)
+                .addComponent(dbEditButton)
+                .addContainerGap())
+        );
+        jPanel2Layout.setVerticalGroup(
+            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
+            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
+                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 342, Short.MAX_VALUE)
+                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
+                .addComponent(dbEditButton)
+                .addContainerGap())
+        );
+
+        tabbedPane.addTab("Inspektor databáze", jPanel2);
+
+        mainPanel.add(tabbedPane);
+
+        getContentPane().add(mainPanel);
+
+        pack();
+    }// </editor-fold>//GEN-END:initComponents
+
+    private void renamerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_renamerButtonActionPerformed
+        assert streetModel.elems.size() == streetModel.names.size();
+        Reasoner r = Reasoner.getInstance();
+
+        synchronized (r) {
+            r.openTransaction();
+            for(int i=0; i<streetModel.elems.size(); i++) {
+                streetModel.elems.get(i).setName(streetModel.names.get(i));
+                r.update(streetModel.elems.get(i));
+            }
+            r.closeTransaction();
+        }
+
+        streetModel.elems.clear();
+        streetModel.names.clear();
+        jPanel1.setVisible(false);
+    }//GEN-LAST:event_renamerButtonActionPerformed
+
+    private AddressElement dbTreeValue = null;
+
+    private void dbTreeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_dbTreeValueChanged
+        dbTreeValue = (AddressElement) dbTree.getSelectionPath().getLastPathComponent();
+        dbEditButton.setEnabled(dbTreeValue instanceof Street);
+    }//GEN-LAST:event_dbTreeValueChanged
+
+    private void dbEditButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dbEditButtonActionPerformed
+        if (dbTreeValue instanceof Street)
+            if (StreetEditor.editStreet((Street) dbTreeValue))
+                dbTree.repaint();
+    }//GEN-LAST:event_dbEditButtonActionPerformed
+
+    // Variables declaration - do not modify//GEN-BEGIN:variables
+    private javax.swing.JButton dbEditButton;
+    private javax.swing.JTree dbTree;
+    private javax.swing.JPanel jPanel1;
+    private javax.swing.JPanel jPanel2;
+    private javax.swing.JScrollPane jScrollPane1;
+    private javax.swing.JPanel mainPanel;
+    private javax.swing.JTable renameTable;
+    private javax.swing.JButton renamerButton;
+    private javax.swing.JScrollPane streetScrollPane;
+    private javax.swing.JTabbedPane tabbedPane;
+    // End of variables declaration//GEN-END:variables
+
+    private class AddressElementRenderer extends DefaultTableCellRenderer {
+
+        public AddressElementRenderer() {}
+
+        @Override
+        protected void setValue(Object value) {
+            super.setValue(value);
+
+            if (value instanceof AddressElement)
+                setText(((AddressElement) value).getName() );
+        }
+    }
+
+    private class RenameModel<Element> implements TableModel {
+
+        List<Element> elems = new ArrayList<Element>();
+        List<String>  names = new ArrayList<String>();
+
+        public int getRowCount() {
+            assert elems.size() == names.size();
+            return elems.size();
+        }
+
+        public int getColumnCount() {
+            return 2;
+        }
+
+        public String getColumnName(int columnIndex) {
+            if (columnIndex == 0) return "Původní název";
+            if (columnIndex == 1) return "Navržený název";
+            assert false : columnIndex;
+            return null;
+        }
+
+        public Class<?> getColumnClass(int columnIndex) {
+            if (columnIndex == 0) return AddressElement.class;
+            if (columnIndex == 1) return String.class;
+            assert false : columnIndex;
+            return null;
+        }
+
+        public boolean isCellEditable(int rowIndex, int columnIndex) {
+            return columnIndex == 1;
+        }
+
+        public Object getValueAt(int rowIndex, int columnIndex) {
+            if (columnIndex == 0) return elems.get(rowIndex);
+            if (columnIndex == 1) return names.get(rowIndex);
+            assert false : columnIndex;
+            return null;
+        }
+
+        public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
+            assert columnIndex == 1;
+            names.set(rowIndex, (String) aValue);
+        }
+
+        public void addTableModelListener(TableModelListener l) {
+
+        }
+
+        public void removeTableModelListener(TableModelListener l) {
+
+        }
+    }
+}
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/PointManipulatorDialog.form
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/PointManipulatorDialog.form	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/PointManipulatorDialog.form	(revision 15582)
@@ -22,5 +22,5 @@
     <AuxValue name="FormSettings_variablesLocal" type="java.lang.Boolean" value="false"/>
     <AuxValue name="FormSettings_variablesModifier" type="java.lang.Integer" value="2"/>
-    <AuxValue name="designerSize" type="java.awt.Dimension" value="-84,-19,0,5,115,114,0,18,106,97,118,97,46,97,119,116,46,68,105,109,101,110,115,105,111,110,65,-114,-39,-41,-84,95,68,20,2,0,2,73,0,6,104,101,105,103,104,116,73,0,5,119,105,100,116,104,120,112,0,0,1,11,0,0,1,-79"/>
+    <AuxValue name="designerSize" type="java.awt.Dimension" value="-84,-19,0,5,115,114,0,18,106,97,118,97,46,97,119,116,46,68,105,109,101,110,115,105,111,110,65,-114,-39,-41,-84,95,68,20,2,0,2,73,0,6,104,101,105,103,104,116,73,0,5,119,105,100,116,104,120,112,0,0,1,21,0,0,1,-79"/>
   </AuxValues>
 
@@ -49,12 +49,9 @@
                       </Group>
                       <Component id="alternateNumberEdit" alignment="0" pref="293" max="32767" attributes="0"/>
-                      <Group type="102" alignment="1" attributes="0">
-                          <Component id="matchesComboBox" pref="186" max="32767" attributes="0"/>
-                          <EmptySpace max="-2" attributes="0"/>
-                          <Component id="ensureConsistencyButton" min="-2" max="-2" attributes="0"/>
-                      </Group>
+                      <Component id="matchesComboBox" alignment="0" pref="293" max="32767" attributes="0"/>
                   </Group>
               </Group>
-              <Component id="jScrollPane1" alignment="1" pref="433" max="32767" attributes="0"/>
+              <Component id="statusLabel" alignment="0" pref="433" max="32767" attributes="0"/>
+              <Component id="jScrollPane1" alignment="0" pref="433" max="32767" attributes="0"/>
           </Group>
         </DimensionLayout>
@@ -76,11 +73,9 @@
                       <Component id="jLabel6" alignment="3" min="-2" max="-2" attributes="0"/>
                       <Component id="matchesComboBox" alignment="3" min="-2" max="-2" attributes="0"/>
-                      <Component id="ensureConsistencyButton" alignment="3" min="-2" max="-2" attributes="0"/>
                   </Group>
-                  <EmptySpace pref="176" max="32767" attributes="0"/>
-              </Group>
-              <Group type="102" alignment="0" attributes="0">
-                  <EmptySpace min="-2" pref="92" max="-2" attributes="0"/>
-                  <Component id="jScrollPane1" pref="175" max="32767" attributes="0"/>
+                  <EmptySpace max="-2" attributes="0"/>
+                  <Component id="jScrollPane1" pref="161" max="32767" attributes="0"/>
+                  <EmptySpace max="-2" attributes="0"/>
+                  <Component id="statusLabel" min="-2" max="-2" attributes="0"/>
               </Group>
           </Group>
@@ -154,17 +149,8 @@
           </Properties>
         </Component>
-        <Component class="javax.swing.JButton" name="ensureConsistencyButton">
+        <Component class="javax.swing.JLabel" name="statusLabel">
           <Properties>
-            <Property name="icon" type="javax.swing.Icon" editor="org.netbeans.modules.form.RADConnectionPropertyEditor">
-              <Connection code="ImageProvider.get(&quot;actions&quot;, &quot;refresh-small.png&quot;)" type="code"/>
-            </Property>
-            <Property name="text" type="java.lang.String" editor="org.netbeans.modules.form.RADConnectionPropertyEditor">
-              <Connection code="&quot;&quot;" type="code"/>
-            </Property>
-            <Property name="toolTipText" type="java.lang.String" value="Provede nov&#xe9; p&#x159;i&#x159;azen&#xed; prvk&#x16f; mapy na elementy datab&#xe1;ze.&#xa;Touto volbou se zru&#x161;&#xed; v&#x161;echny manu&#xe1;ln&#x11b; vy&#x159;e&#x161;en&#xe9; konflikty."/>
+            <Property name="text" type="java.lang.String" value=" "/>
           </Properties>
-          <Events>
-            <EventHandler event="actionPerformed" listener="java.awt.event.ActionListener" parameters="java.awt.event.ActionEvent" handler="ensureConsistencyButtonActionPerformed"/>
-          </Events>
         </Component>
       </SubComponents>
